# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/org/jboss/ejb3/%{name}/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define namedversion %{version}

Name:           jboss-ejb3-timerservice-spi
Version:        1.0.4
Release:        0.1%{?dist}
Epoch:          0
Summary:        JBoss EJB3 Timerservice SPI
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.jboss.org/
# svn export http://anonsvn.jboss.org/repos/jbossas/projects/ejb3/tags/jboss-ejb3-timerservice-spi-1.0.4/ && tar cjf jboss-ejb3-timerservice-spi-1.0.4.tar.bz2 jboss-ejb3-timerservice-spi-1.0.4
# Exported revision 110690.
Source0:        jboss-ejb3-timerservice-spi-1.0.4.tar.bz2
Source1:        jboss-ejb3-timerservice-spi-jpp-depmap.xml
Source2:        jboss-ejb3-timerservice-spi-settings.xml
Source3:	jboss-ejb3-timerservice-spi-component-info.xml
# Based on: svn diff -c-106490 http://anonsvn.jboss.org/repos/jbossas/projects/ejb3/trunk/timerservice-spi/
Patch0:         jboss-ejb3-timerservice-spi-no-ejb-3.1-api.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       java >= 0:1.5.0
Requires:       jboss-ejb-3.0-api
Requires:       jboss-ejb3-build
Requires:       jpackage-utils
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-rar
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-jboss-deploy-plugin
BuildRequires:  maven-release
BuildRequires:  maven-enforcer-rule-api
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  jboss-ejb-3.0-api
BuildRequires:	jboss-parent
BuildRequires:  jbossws-parent
BuildRequires:  jbossws
BuildRequires:  jboss-ejb3-build
BuildRequires:  junit
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss EJB timerservice SPI.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q 
%patch0 -p0 -b .sav0

%build
%{__cp} -p %{SOURCE2} maven2-settings.xml

%{__sed} -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
%{__sed} -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

%{__mkdir} external_repo
%{__ln_s} %{_javadir} external_repo/JPP

export M2SETTINGS=`pwd`/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.test.failure.ignore=true \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -DaltDeploymentRepository=jboss-releases::default::file:`pwd`/maven2-brew \
        -Djboss.repository.root=jboss-releases::default::file:`pwd`/maven2-brew \
        deploy javadoc:javadoc

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p target/%{name}.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar
%{__cp} -p target/%{name}-sources.jar %{buildroot}%{_javadir}/%{name}-%{namedversion}-sources.jar
%{jar} -cf %{buildroot}%{_javadir}/%{name}-%{namedversion}-javadoc.jar -C target/site/apidocs/ .
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo $jar | %{__sed} "s|-%{namedversion}||g"`; done)

# pom
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.jboss.ejb3 %{name} %{namedversion} JPP %{name}

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{namedversion}
%{__ln_s} %{name}-%{namedversion} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com
%{__cp} -pr maven2-brew %{buildroot}%{_javadir}/repository.jboss.com
%{_bindir}/mvn-jpp deploy:deploy-file -e -DpomFile=pom.xml -DrepositoryId=maven2-brew \
    -Durl=file:%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew \
    -Dfile=%{buildroot}%{_javadir}/%{name}-%{namedversion}-javadoc.jar \
    -Dclassifier=javadoc
%{__mkdir_p} %{buildroot}%{repodir}
%{__cp} -p %{SOURCE3} %{buildroot}%{repodir}/component-info.xml
tag=`echo %{namedversion}-brew`
%{__sed} -i "s/@VERSION@/$tag/g" %{buildroot}%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | %{__sed} 's|\.|_|g'`
%{__sed} -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
%{__mkdir_p} %{buildroot}%{repodir}
%{__mkdir_p} %{buildroot}%{repodirlib}
%{__mkdir_p} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE0} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE1} %{buildroot}%{repodirsrc}
%{__cp} -p %{SOURCE2} %{buildroot}%{repodirsrc}
%{__cp} -p %{PATCH0} %{buildroot}%{repodirsrc}
%{__cp} -p %{buildroot}%{_javadir}/%{name}-%{namedversion}.jar %{buildroot}%{repodirlib}/%{name}.jar
%{__cp} -p %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom %{buildroot}%{repodirlib}/%{name}.pom
%{__cp} -p %{buildroot}%{_javadir}/%{name}-%{namedversion}-javadoc.jar %{buildroot}%{repodirlib}/%{name}-javadoc.jar
%{__cp} -p %{buildroot}%{_javadir}/%{name}-%{namedversion}-sources.jar %{buildroot}%{repodirlib}/%{name}-sources.jar
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-%{namedversion}.jar
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-%{namedversion}-javadoc.jar
%{_javadir}/%{name}-javadoc.jar
%{_javadir}/%{name}-%{namedversion}-sources.jar
%{_javadir}/%{name}-sources.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{namedversion}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%exclude %dir %{_javadocdir}
%{_javadir}/repository.jboss.com
%endif

%changelog
* Wed Feb 16 2011 David Walluck <dwalluck@redhat.com> 0:1.0.4-0.1
- fix duplicate install call
- fix repolib
- remove incorrect BuildRequires
- fix maven2 BuildRequires

* Tue Jan 18 2011 Martha Benitez <mbenitez@redhat.com> - 0:1.0.0-1.6
- Rebuild for MEAD
- Add BR qdox

* Thu Nov 25 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.0-1.5
- Build with maven 2.2.1
- Change BR maven-release to maven-release-plugin
- Add BR maven-deploy-plugin
 
* Thu May 06 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.0-1.4.1
- rebuilt

* Wed Apr 07 2010 Hui Wang <huwang@redhat.com> - 0;1.0.0-1.4
- Rebuild

* Fri Dec 04 2009 Martha Benitez <mbenitez@redhat.com> - 0:1.0.1-1.3
- Add javadoc and sources jar files to main packege and repolib
- Change jboss-parent.pom to BR jboss-parent

* Thu Sep 17 2009 Martha Benitez <mbenitez@redhat.com> - 0:1.0.1-1.2
- Add repolib

* Tue Sep 1 2009 Yong Yang <yyang@redhat.com> - 0:1.0.1-1.1
- Import from jpackage
- Change BR maven-shared-enforcer-rule-api to maven-enforcer-rule-api
- BR jbossws
- Add jpp depmap for jboss-parent, jsr173_api, jbossws

* Sat Jul 25 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.0.0-1
- first release
